
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>netty实现消息转发服务 / 憋错料</title>

    <meta name="description" content="netty实现消息转发服务 1.结构图 2.消息服务器 消息服务器(SNS)由Http Netty Server(HNS)和WebSocket Netty Server(WNS)组成.HNS采用Netty Http+XML协议栈开发实现,WNS采用Netty WebSocket+JSON实现. HNS只接收预定义的HttpXmlRequest类型的数据,这由编解码器控制,编解码器是继承了MessageToMessageDecoder&lt;T&gt;和MessageToMessageEncoder&lt;T&gt;这两个编 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">netty实现消息转发服务</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>1、结构图</strong></p>
<p>　　<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzMzMzUyOS8yMDE2MTAvMzMzNTI5LTIwMTYxMDEwMTY0OTU4ODk5LTE0MjYwNjkwNzEucG5n.jpg" /></p>
<p><strong>2、消息服务器</strong></p>
<p>消息服务器（SNS）由Http Netty Server(HNS)和WebSocket Netty Server(WNS)组成。HNS采用Netty Http+XML协议栈开发实现，WNS采用Netty WebSocket+JSON实现。</p>
<p>HNS只接收预定义的HttpXmlRequest类型的数据，这由编解码器控制，编解码器是继承了MessageToMessageDecoder&lt;T&gt;和MessageToMessageEncoder&lt;T&gt;这两个编解码基础类、并用于解析处理预定义HttpXmlRequest数据的类。HNS根据接收结果向客户端发送预定义的HttpXmlResponse类型数据。</p>
<p>HNS可以通过HttpXmlClient创建与业务服务器的链接，并通过HttpXmlClientHandler转发业务请求。HttpXmlClientHandler继承自SimpleChannelInboundHandler，通过它可以实现HNS与业务服务器的异步通信。</p>
<p>目前，WNS主要用于与Web客户端端进行websocket通信，WNS通过全局变量Global.WSCG维护通道信息，通过Global.appUsers维护客户端连接。WNS定义了一个消息基类BaseMsg，该类描述了客户端发起请求所需要的数据信息。同样，WNS也定义了一个AppUser类用于存储客户端信息，必须说明的一点是，同一个AppUser可能存在多个通道，因此，在AppUser中定义了一个ChannelId数组，该数组维护了当前用户的所有通道ID。客户端发起连接请求时，必要的数据包括appid、userId、cmd，appid是一个业务服务器的唯一标识。</p>
<p><strong>3、业务服务器</strong></p>
<p>业务服务器是各个应用端建立的与SNS交互的Http Netty Server，换句话说，每一个应用都需要启动一个HNS用于与SNS交互。同样的，业务服务器也是通过HttpXmlClient向SNS的HNS发起连接请求，不再赘述。</p>
<p><strong>4、HttpXmlServer</strong></p>
<pre>package com.sns.protocol.http.xml.server;

import java.net.InetSocketAddress;

import com.zehin.sns.protocol.http.xml.codec.HttpXmlRequest;
import com.zehin.sns.protocol.http.xml.codec.HttpXmlRequestDecoder;
import com.zehin.sns.protocol.http.xml.codec.HttpXmlResponseEncoder;
import com.zehin.sns.protocol.http.xml.pojo.HttpRequestMessage;

import io.netty.bootstrap.ServerBootstrap;
import io.netty.channel.AdaptiveRecvByteBufAllocator;
import io.netty.channel.ChannelFuture;
import io.netty.channel.ChannelInitializer;
import io.netty.channel.ChannelOption;
import io.netty.channel.EventLoopGroup;
import io.netty.channel.SimpleChannelInboundHandler;
import io.netty.channel.nio.NioEventLoopGroup;
import io.netty.channel.socket.SocketChannel;
import io.netty.channel.socket.nio.NioServerSocketChannel;
import io.netty.handler.codec.http.HttpObjectAggregator;
import io.netty.handler.codec.http.HttpRequestDecoder;
import io.netty.handler.codec.http.HttpResponseEncoder;

public class HttpXmlServer implements Runnable {

	private EventLoopGroup bossGroup = null;
	private EventLoopGroup workerGroup = null;
	private SimpleChannelInboundHandler&lt;HttpXmlRequest&gt; handler = null;

	private int port = 9999;

	@SuppressWarnings("unused")
	private HttpXmlServer() {
	}

	public HttpXmlServer(int _port, SimpleChannelInboundHandler&lt;HttpXmlRequest&gt; _handler) {
		this.port = _port;
		this.handler = _handler;
	}

	@Override
	public void run() {
		// 处理网络连接---接受请求
		bossGroup = new NioEventLoopGroup();
		// 进行socketChannel的网络读写
		workerGroup = new NioEventLoopGroup();
		try {
			ServerBootstrap b = new ServerBootstrap();
			b.group(bossGroup, workerGroup).channel(NioServerSocketChannel.class)
					// boss线程接收参数设置，BACKLOG用于构造服务端套接字ServerSocket对象，
					// 标识当服务器请求处理线程全满时，用于临时存放已完成三次握手的请求的队列的最大长度。
					// 如果未设置或所设置的值小于1，Java将使用默认值50。
					.option(ChannelOption.SO_BACKLOG, 1024)
					// 发送缓冲器
					.option(ChannelOption.SO_SNDBUF, 1024)
					// 接收缓冲器
					.option(ChannelOption.SO_RCVBUF, 1024)
					// 接收缓冲分配器
					.option(ChannelOption.RCVBUF_ALLOCATOR, new AdaptiveRecvByteBufAllocator(256, 2048, 65536))
					// work线程参数设置
					.childOption(ChannelOption.RCVBUF_ALLOCATOR, new AdaptiveRecvByteBufAllocator(256, 2048, 65536))
					.childHandler(new ChannelInitializer&lt;SocketChannel&gt;() {
						@Override
						protected void initChannel(SocketChannel ch) throws Exception {
							ch.pipeline().addLast("http-decoder", new HttpRequestDecoder());
							ch.pipeline().addLast("http-aggregator", new HttpObjectAggregator(65536));
							ch.pipeline().addLast("xml-decoder",
									new HttpXmlRequestDecoder(HttpRequestMessage.class, true));
							ch.pipeline().addLast("http-encoder", new HttpResponseEncoder());
							ch.pipeline().addLast("xml-encoder", new HttpXmlResponseEncoder());
							ch.pipeline().addLast("xmlServerHandler", handler);
						}
					});
			ChannelFuture future = b.bind(new InetSocketAddress(port)).sync();
			System.out.println("HTTP netty server started. the port is " + port);
			future.channel().closeFuture().sync();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			bossGroup.shutdownGracefully();
			workerGroup.shutdownGracefully();
		}
	}

	public void shutdown() {
		if (bossGroup != null)
			bossGroup.shutdownGracefully();
		if (workerGroup != null)
			workerGroup.shutdownGracefully();
	}
}
</pre>
<p><strong>5、HttpXmlServerHandler</strong></p>
<pre>package com.sns.protocol.http.xml.server;

import static io.netty.handler.codec.http.HttpHeaders.isKeepAlive;
import static io.netty.handler.codec.http.HttpHeaders.Names.CONTENT_TYPE;
import static io.netty.handler.codec.http.HttpResponseStatus.INTERNAL_SERVER_ERROR;
import static io.netty.handler.codec.http.HttpVersion.HTTP_1_1;

import com.zehin.sns.protocol.http.xml.codec.HttpXmlRequest;
import com.zehin.sns.protocol.http.xml.codec.HttpXmlResponse;
import com.zehin.sns.protocol.http.xml.pojo.HttpRequestMessage;
import com.zehin.sns.protocol.http.xml.pojo.HttpResponseMessage;

import io.netty.buffer.Unpooled;
import io.netty.channel.ChannelFuture;
import io.netty.channel.ChannelFutureListener;
import io.netty.channel.ChannelHandler.Sharable;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import io.netty.handler.codec.http.DefaultFullHttpResponse;
import io.netty.handler.codec.http.FullHttpResponse;
import io.netty.handler.codec.http.HttpRequest;
import io.netty.handler.codec.http.HttpResponseStatus;
import io.netty.util.CharsetUtil;
import io.netty.util.concurrent.Future;
import io.netty.util.concurrent.GenericFutureListener;

@Sharable
public final class HttpXmlServerHandler extends SimpleChannelInboundHandler&lt;HttpXmlRequest&gt; {

	@Override
	public void messageReceived(final ChannelHandlerContext ctx, HttpXmlRequest xmlRequest) throws Exception {
		HttpRequest request = xmlRequest.getRequest();
		HttpRequestMessage reqMessage = (HttpRequestMessage) xmlRequest.getBody();
		System.out.println("Http server receive request : " + reqMessage);
		HttpResponseMessage resMessage = dobusiness(reqMessage);
		ChannelFuture future = ctx.writeAndFlush(new HttpXmlResponse(null, resMessage));
		if (!isKeepAlive(request)) {
			future.addListener(new GenericFutureListener&lt;Future&lt;? super Void&gt;&gt;() {
				public void operationComplete(Future future) throws Exception {
					ctx.close();
				}
			});
		}
	}

	private HttpResponseMessage dobusiness(HttpRequestMessage req) {
		HttpResponseMessage resMessage = new HttpResponseMessage();
		if (req.getCmd() == 0) {
			resMessage.setResult(true);
		} else {
			// other verify code here...
		}
		return resMessage;
	}

	@Override
	public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
		cause.printStackTrace();
		if (ctx.channel().isActive()) {
			sendError(ctx, INTERNAL_SERVER_ERROR);
		}
	}

	private static void sendError(ChannelHandlerContext ctx, HttpResponseStatus status) {
		FullHttpResponse response = new DefaultFullHttpResponse(HTTP_1_1, status,
				Unpooled.copiedBuffer("失败: " + status.toString() + "\r\n", CharsetUtil.UTF_8));
		response.headers().set(CONTENT_TYPE, "text/plain; charset=UTF-8");
		ctx.writeAndFlush(response).addListener(ChannelFutureListener.CLOSE);
	}
}
</pre>
<p><strong>6、备注</strong></p>
<p><strong>　　主要参考《Netty权威指南》而写了个简单的消息转发。</strong></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-07 04:12:48 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>netty实现消息转发服务的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MP8XrmM.html" rel="bookmark">基于netty4的tcp消息转发服务--外包接的一个小项目</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				git地址 https://git.oschina.net/cggxx/CubeBox.git 分包 tcp分包采用的格式是 消息类型两个字节 | 内容长度两个字节 | 内容 长连接 tcp长连接使用心跳保证连接 连接验证 和客户端约定验证算法,具体看代码. 这是个人接的一个小项目,现在已经上线,连接物联网用的,由于交了代码后,没拿到钱,于是就当小项目开源了.本来打算用zookeeper建立集群的,后来懒,整了一半没弄完,以后再加			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NlW760.html" rel="bookmark">微信二次开发sdk使用教程--手机微信上回复好友的聊天消息通知服务端</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				微信二次开发sdk使用教程--手机微信上回复好友的聊天消息通知服务端 case WeChatTalkToFriendNotice: {// 手机上回复好友的聊天消息 log.debug(&quot;socket:msgtype=WeChatTalkToFriendNotice&quot;); weChatTalkToFriendNoticeHandler.handleMsg(ctx, msgVo); break; } package com.jubotech.framework.netty.handler			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgeAGK3.html" rel="bookmark">微信开发SDK使用教程--手机微信好友发来聊天消息通知服务端</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				微信开发SDK使用教程--手机微信好友发来聊天消息通知服务端 case FriendTalkNotice: {// 微信好友发来聊天消息 log.debug(&quot;socket:msgtype=FriendTalkNotice&quot;); friendTalkNoticeHandler.handleMsg(ctx, msgVo); break; } package com.jubotech.framework.netty.handler.socket; import org.slf4j.Logg			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JvnbP4.html" rel="bookmark">浅析腾讯云分布式高可靠消息队列服务CMQ架构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在分布式大行其道的今天,我们在系统内部.平台之间广泛运用消息中间件进行数据交换及解耦.CMQ是腾讯云内部自研基于的高可靠.强一致.可扩展分布式消息队列,在腾讯内部包括微信手机QQ业务红包.腾讯话费充值.广告订单等都有广泛使用.目前已上线腾讯云对外开放,本文对腾讯云CMQ核心技术原理进行分享介绍. CMQ消息队列主要适用于金融.交易.订单等对可靠性.可用性有较高要求的业务场景. 以腾讯充值系统为例,该充值系统通过CMQ 对交易模块.发货部分.结算系统进行异步解耦.削峰填谷,一方面大大降低了模块间耦			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KP6Yw3.html" rel="bookmark">Android 基于Netty的消息推送方案之对象的传递（四）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上一篇文章中&lt;Android 基于Netty的消息推送方案之字符串的接收和发送(三)&gt;我们介绍了Netty的字符串传递,我们知道了Netty的消息传递都是基于流,通过ChannelBuffer传递的,那么自然,Object也需要转换成ChannelBuffer来传递.好在Netty本身已经给我们写好了这样的转换工具.ObjectEncoder和ObjectDecoder,下面我们介绍一个案例. 1. 我们构造一个用来传输的对象(JavaBean) [java] view plaincopy			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bL1G94.html" rel="bookmark">Android 基于Netty的消息推送方案之字符串的接收和发送（三）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上一篇文章中&lt;Android 基于Netty的消息推送方案之概念和工作原理(二)&gt; ,我们介绍过一些关于Netty的概念和工作原理的内容,今天我们先来介绍一个叫做ChannelBuffer的东东. ChannelBuffer Netty中的消息传递,都必须以字节的形式,以ChannelBuffer为载体传递.简单的说,就是你想直接写个字符串过去,对不起,抛异常.虽然,Netty定义的writer的接口参数是Object的,这可能也是会给新上手的朋友容易造成误会的地方.Netty源码中,是这样			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPgb1D4.html" rel="bookmark">SmartRoute之大规模消息转发集群实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				消息转发的应用场景在现实中的应用非常普遍,我们常用的IM工具也是其中之一:现有很多云平台也提供了这种基础服务,可以让APP更容易集成相关功能而不必投入相应的开发成本.对于实现这样一个简单功能并不复杂,对于现有的技术来说用.net提个通讯服务器支持几十W用户相信也不是件困难的事情:但如果考虑可用性和更大规模那就需要下点功夫,并且对相关技术有深入的了解才能实现了.而在这里主要讲解一下如何通过SmartRoute来实现一个大规模的消息转发集群的基础服务. 说到集群那肯定由N个服务组成的一组应,那做一个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38qe2R4.html" rel="bookmark">微信公众平台多客服新增自定义客服头像和消息转发接口功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				多客服一般是开放给微信认证服务号的一个便捷功能,可以将消息转发到多客服方便回复.对有些“选择综合症“的客服,看到那一层不变的客服头像就想吐槽.现在好了,多客服新增自定义客服头像和接口功能,也可以自定义昵称 一.开通“多客服”的公众号可为客服工号配置自定义头像. 使用6.0.2版微信的用户在同公众号进行客服沟通时,可以看到配置的客服头像和昵称. 二.为满足公众号个性化客服需求,公众平台为开发者提供了“多客服”相关接口,可将消息转发到多客服 和 消息转发到指定客服. A:如果公众号处于开发模式,普通			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YvJ2W3.html" rel="bookmark">消息队列服务Kafka揭秘：痛点、优势以及适用场景</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要: 消息队列Kafka是一个分布式的.高吞吐量.高可扩展性消息队列服务,广泛用于日志收集.监控数据聚合.流式数据处理.在线和离线分析等,是大数据生态中不可或缺的产品之一,阿里云提供全托管服务,用户无需部署运维,更专业.更可靠.更安全.本文就将带你走进消息队列Kafka. 摘要:消息队列Kafka是一个分布式的.高吞吐量.高可扩展性消息队列服务,广泛用于日志收集.监控数据聚合.流式数据处理.在线和离线分析等,是大数据生态中不可或缺的产品之一,阿里云提供全托管服务,用户无需部署运维,更专业.更可			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/D3OpWZ4.html" rel="bookmark" class="title">架建一台LINUX的DHCP服务器</a>
					<div>
						要求,1.DHCP的IP192.168.1.252 2.分配192.168.1.10-200的IP地址, 3.A主机,固定IP A    00:0C:29:A8:43:F0             1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QNDgEM.html" rel="bookmark" class="title">初识AFAIDE</a>
					<div>
						AFAIED,基本不用写代码,不用看代码.关注的重点的对流程的初次划分和再划分.开始项目时,通过SVN获得项目的代码(这里要知道SVN的地址,AFA服务器存储项目的地址,端口的相关配置).才测试交易是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLj2Ge3.html" rel="bookmark" class="title">TP实例化模型的两种方式 M&lpar;&rpar;   D&lpar;&rpar;</a>
					<div>
						TP框架中实例化模型的两种方式 #如果使用自己自定义的函数,那么就用D $mode=D('model'); #如果使用是系统自带的函数,那么就是用M $model=M('model');					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47qLz60.html" rel="bookmark" class="title">linux SFTP用户创建 不允许用户登录，并且连接只允许在制定的目录下进行操作</a>
					<div>
						1.创建用户 groupadd sftp 2.添加用户并设置为sftp组 useradd -g sftp -s /sbin/nologin -M sftp    (/sbin/nologin为禁止登录 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0n5k6KM.html" rel="bookmark" class="title">1403 约数研究</a>
					<div>
						难度:普及- 题目类型:简单数学问题 提交次数:1 涉及知识:数学 题目描述 科学家们在Samuel星球上的探险得到了丰富的能源储备,这使得空间站中大型计算机“Samuel II”的长时间运算成为了可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RGd673.html" rel="bookmark" class="title">iOS开发&mdash;&mdash;model类模板（过滤null和ID）</a>
					<div>
						        说明:model类模板已默认过滤null值,附加特殊情况的关键字ID名的冲突(需手动去掉注释代码).MyMessageModel为示例的名字.可以自己随便起. 1.自己创建一个继承与N ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jXqpZ4.html" rel="bookmark" class="title">引用类型2 Array（转换方法和栈方法）&mdash;&mdash;JS学习笔记2015-6-25&lpar;第66天&rpar;</a>
					<div>
						转换方法: 所有对象都具有toString().toLocaleString()和valueOf()方法: toString()方法会返回由数组中每个值的字符串形式拼接而成的一个以逗号分隔的字符串 调 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l5neP3.html" rel="bookmark" class="title">iOS开发&mdash;&mdash;多线程OC篇&amp;amp&semi;（九）多线程NSOperation介绍</a>
					<div>
						NSOperation介绍 一.NSOperation简介 1.简单说明 NSOperation的作?:配合使用NSOperation和NSOperationQueue也能实现多线程编程 NSOper ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz1rw24.html" rel="bookmark" class="title">2017湖南省赛心得</a>
					<div>
						没参赛···全程观战,这次一银二铜. 除了题目本身还有一些要注意的. 1.带草稿纸和本子和一些重要证件+物件和时间观念. 2.比赛前 测试头文件(顺便看看键盘哪里有问题,敲头文件的时候就差不多检查到了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qaBmW3.html" rel="bookmark" class="title">2014025629&lpar;3&rpar;《嵌入式系统程序设计》第五周学习总结</a>
					<div>
						这周我又跟老师学到了很多知识 1.函数原型 (1)size_t fread ( void * ptr, size_t size, size_t count, FILE * stream ); 其中,p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YDa7wM.html" rel="bookmark" class="title">特征开源</a>
					<div>
						modesecurity 的特征: https://github.com/SpiderLabs/owasp-modsecurity-crs/tree/master/base_rules snort的规 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wjzrj0.html" rel="bookmark" class="title">Django：Django安装</a>
					<div>
						一.Python安装(Windows) 1.考虑到Django还不支持Python3.0引入的大量不向后兼容的改变,该教程建议选择Python2.6: 2.访问https://www.python.o ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OZOeo0.html" rel="bookmark" class="title">Mac OS X中打zip包时去除&period;DS&lowbar;Store等指定文件</a>
					<div>
						在Finder中的Compress “…”很好用,但是也有烦恼的时候,经常打包会包含进来一些.DS_Store文件,.DS_Store是苹果系统中保存当前目录基本信息的文件,包括图标的位置,显示方式等 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZNRLl3.html" rel="bookmark" class="title">极路由1s手工安装ss插件</a>
					<div>
						1.极路由申请开放root权限,将会失去保修,不过100块的东西还保修个什么 2.用putty连接极路由注意端口号 3. 然后一段一段执行下面的代码,很简单,复制一个段落的代码,粘贴进去,回车执行.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLvZDv3.html" rel="bookmark" class="title">九章算法面试题72 翻转链表I</a>
					<div>
						九章算法官网-原文网址 http://www.jiuzhang.com/problem/73/ 题目 给一个链表,然后我们要把这个链表进行翻转. 在线测试本题 http://www.lintcode. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kNEojM.html" rel="bookmark" class="title">Codeforces 200C</a>
					<div>
						题意:给定一个电阻值,求得到该电阻值所需单位电阻的最小个数. 思路:逆推,大于电阻值1时减至分数,小于1时取倒数,重复操作. &lt;pre class=&quot;sh-cpp sh-sourceC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qbkGG4.html" rel="bookmark" class="title">Codeforces Round &num;290 Div1 B</a>
					<div>
						Problem 有一只青蛙在x轴上跳,起初在原点,现有N种跳跃技能可以购买,每技能有两属性:跳跃长度Li 以及 花费Ci.若购买了第 i 种技能,则可以从 y 位置跳跃到 y+Li 或者 y-Li 位 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pgpVw3.html" rel="bookmark" class="title">ffmpeg画中画效果</a>
					<div>
						1. 画中画效果overlay滤镜 overlay的使用语法: ffmpeg  -i  input1  -i  input2  -filter_complex  overlay=x:y  output ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGnJZQ4.html" rel="bookmark" class="title">&lbrack;设计模式&rsqb; 23 访问者模式 visitor Pattern</a>
					<div>
						在GOF的&lt;设计模式:可复用面向对象软件的基础&gt;一书中对访问者模式是这样说的:表示一个作用于某对象结构中的各元素的操作.它使你可以在不改变各元素的类的前提下定义作用于这些元素的新操作.访问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyDDqa4.html" rel="bookmark" class="title">深入理解absolute</a>
					<div>
						一.absolute和float 1.相同的特性表现: &lt;1&gt;包裹性 &lt;2&gt;破坏性 注意:有时候,其页面布局可以相互替换--------float::=position:abs ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
